Function.prototype.Inherits = function(parent)
{
	this.prototype = new parent();
	this.prototype.constructor = this;
}

Object.prototype.Inherits = function(parent)
{
	if( arguments.length > 1 )
	{
		var args = Array.prototype.slice.call(arguments, 1);
		parent.apply(this, args);
	}
	else
	{
		parent.call(this);
	}
}

// BEGINFILE SfMenu.js --------------------------------------------------------------------------->
var MenuType =
{
	RootMenu : "RootMenu",
	SubMenu : "SubMenu",
	Leaf : "Leaf"
}

function LocationInfo(topOffset, leftOffset, width, height)
{
	this.Width = width;
	this.Height = height;
	this.TopOffset = topOffset;
	this.LeftOffset = leftOffset;
}

function SizeInfo(width, height)
{
	this.Width = width;
	this.Height = height;
}

function MenuItem(container, text, template)
{
	if (container && text && template)
	{
		this.Container = container;
		this.Text = text;
		this.Width = template.LocationInfo.Width;
		this.Height = template.LocationInfo.Height;
		this.TopOffset = template.LocationInfo.TopOffset;
 		this.LeftOffset = template.LocationInfo.LeftOffset;
 		this.Template = template;
	}

	this.MenuType = null;
	this.Parent = null;

	this.RootDiv = null;
	this.TextDiv = null;
	this.DivLeft = null;
	this.DivMiddle = null;
	this.DivRight = null;
	
	this.ZIndex = 1;
		
	this.InitializeCalculator = function()
	{
		if (navigator.userAgent.toLowerCase().indexOf("msie")>1)
		{
			this.Calculator = new IECalculator();
		}
		else
		{ 
			this.Calculator = new NonIECalculator();
		}
	}
		
	this.CreateElement = function(top, left, width, height)
	{
		var elem = document.createElement("div");
		elem.style.position = 'absolute';
		elem.style.top = top + 'px';
		elem.style.left = left + 'px';
		elem.style.width = width + 'px';
		elem.style.height = height + 'px';
		return elem;
	}
	
	this.GetDivClassName = function(hilite, loc)
	{
		alert('should be overridden');
	}
	
	this.Hide = function()
	{
		this.RootDiv.style.visibility = 'hidden';
		this.UnHiliteDiv();
	}
	
	this.Show = function()
	{
		this.RootDiv.style.visibility = 'visible';
	}
	
	this.OnMouseOver = function()
	{
		if (this.Parent != null)
		{
			var children = this.Parent.GetChildren();
			for (var i=0; i<children.length; ++i)
			{
				children[i].CollapseChildrenNow();
			}
		}
		this.ExpandChildrenNow();

		this.HiliteDiv();
		this.HiliteAllParents();	
	}
	
	this.HiliteAllParents = function()
	{
		var current = this;
		var par = current.Parent;
		while (par != null)
		{
			par.HiliteDiv();
			var children = par.GetChildren();
			for (var i=0; i<children.length; ++i)
			{
				if (children[i].Container != current.Container)
				{
					children[i].UnHiliteDiv();
				}
			}
			current = par;
			par = par.Parent;
		}
	}
	
	this.HiliteDiv = function()
	{
		this.DivLeft.className = this.GetDivClassName(true, 'Left');
		this.DivRight.className = this.GetDivClassName(true, 'Right');
		this.DivMiddle.className = this.GetDivClassName(true, 'Middle');
	}
	
	this.OnMouseOut = function()
	{
		this.UnHiliteDiv();
	}
	
	this.UnHiliteDiv = function()
	{
		this.DivLeft.className = this.GetDivClassName(false, 'Left');
		this.DivRight.className = this.GetDivClassName(false, 'Right');
		this.DivMiddle.className = this.GetDivClassName(false, 'Middle');
	}
	
	this.GetRootParent = function()
	{
		var currentElem = this;
		while (currentElem.Parent != null)
		{
			currentElem = currentElem.Parent;
		}
		return currentElem;
	}
	
	this.CollapseChildrenNow = function()
	{
	}
	
	this.ExpandChildrenNow = function()
	{
	}
	
	this.CreateRootDiv = function()
	{
		this.RootDiv = this.CreateElement(this.TopOffset, this.LeftOffset, this.Calculator.GetWidth(this.Width, this.GetBorderWidth()), this.Calculator.GetHeight(this.Height, this.GetBorderWidth()));
	}

	this.GetLeftDivWidth = function()
	{
		return this.Template.LeftDivWidth;
	}
	
	this.GetRightDivWidth = function()
	{
		return this.Template.RightDivWidth;
	}

	this.GetBorderWidth = function()
	{
		return this.Template.ChildBorderWidth;
	}
	
	this.CreateTextDiv = function()
	{
		this.TextDiv = this.CreateElement(0, 0, this.Calculator.GetWidth(this.Width, this.GetBorderWidth()), this.Calculator.GetHeight(this.Height, this.GetBorderWidth()));
		this.RootDiv.appendChild(this.TextDiv);

		this.DivLeft = this.CreateElement(0, 0, this.GetLeftDivWidth(), this.Height-2*this.GetBorderWidth());
		this.DivLeft.className = this.GetDivClassName(false, 'Left');
		this.TextDiv.appendChild(this.DivLeft);

		this.DivMiddle = this.CreateElement(0, this.GetLeftDivWidth(), this.Calculator.GetPaddingBorderAdjustment(this.Width - (this.GetLeftDivWidth() + this.GetRightDivWidth()), this.GetBorderWidth(), this.Template.PaddingLeft), this.Calculator.GetPaddingBorderAdjustment(this.Height, this.GetBorderWidth(), this.Template.PaddingTop));
		this.DivMiddle.className = this.GetDivClassName(false, 'Middle');
		this.DivMiddle.style.paddingLeft = this.Template.PaddingLeft + 'px';
		this.DivMiddle.style.paddingTop = this.Template.PaddingTop + 'px';
		this.DivMiddle.appendChild(document.createTextNode(this.Text));
		this.TextDiv.appendChild(this.DivMiddle);

		this.DivRight = this.CreateElement(0, this.Width-this.GetRightDivWidth()-2*this.GetBorderWidth(), this.GetRightDivWidth(), this.Height-2*this.GetBorderWidth());
		this.DivRight.className = this.GetDivClassName(false, 'Right');
		this.TextDiv.appendChild(this.DivRight);
		
		this.TextDiv.onmouseover = new Function("", this.Container + ".OnMouseOver();");
		this.TextDiv.onmouseout = new Function("", this.Container + ".OnMouseOut();");
	}
	
}

LeafItem.Inherits(MenuItem);
function LeafItem(container, text, template, onClickFunction)
{
	if (container)
	{
		this.Inherits(MenuItem, container, text, template)
		this.OnClickFunction = onClickFunction;
	}
	
	this.MenuType = MenuType.Leaf;
	this.IsSelectedLeaf = false;
	
	this.Create = function()
	{
		this.InitializeCalculator();
		this.CreateRootDiv();
		this.CreateTextDiv();
		this.TextDiv.onclick = new Function("", this.Container + ".OnClick();");
	}
	
	this.OnClick = function()
	{
		var rootParent = this.GetRootParent();
		rootParent.CollapseChildrenNow();
		rootParent.Expanded = false;
		rootParent.UnHiliteDiv();
		if (this.OnClickFunction)
		{
			this.OnClickFunction();
		}
		
		if (this.Group)
		{
			this.Group.Select(this);
		}
	}

	this.GetDivClassName = function(hilite, loc)
	{
		if (hilite == true)
		{
			if (this.IsSelectedLeaf == true)
			{
				return 'div' + this.Template.CssPrefix + 'SelectedLeaf' + loc + 'Over';
			}
			else
			{
				return 'div' + this.Template.CssPrefix + loc + 'Over';
			}
		}
		else
		{
			if (this.IsSelectedLeaf == true)
			{
				return 'div' + this.Template.CssPrefix + 'SelectedLeaf' + loc;
			}
			else
			{
				return 'div' + this.Template.CssPrefix + loc;
			}
		}
	}
}

function LeafGroup()
{
	this.Leafs = new Array();
	this.Add = function(leaf)
	{
		this.Leafs[this.Leafs.length] = leaf;
		leaf.Group = this;
	}
	
	this.Select = function(leaf)
	{
		for (var i=0; i<this.Leafs.length; ++i)
		{
			if (this.Leafs[i].Container == leaf.Container)
			{
				this.Leafs[i].IsSelectedLeaf = true;
			}
			else
			{
				this.Leafs[i].IsSelectedLeaf = false;
			}
			this.Leafs[i].UnHiliteDiv();
		}
	}
}

SubMenuItem.Inherits(MenuItem);
function SubMenuItem(container, text, template)
{
	if (container)
	{
		this.Inherits(MenuItem, container, text, template);
		this.SubMenuWidth = this.Template.SubMenuSizeInfo.Width;
		this.SubMenuHeight = this.Template.SubMenuSizeInfo.Height;
	}
	
	this.MenuType = MenuType.SubMenu;

	this.ChildDiv = null;
	this.Children = null;
	
	this.GetDivClassName = function(hilite, loc)
	{
		if (hilite == true)
		{
			return 'div' + this.Template.CssPrefix + 'SubMenu' + loc + 'Over';
		}
		else
		{
			return 'div' + this.Template.CssPrefix + 'SubMenu' + loc;
		}
	}
	
	this.GetChildren = function()
	{
		return this.Children;
	}
	
	this.AddLeaf = function(text, onClickFunction)
	{
		var template = this.Template.Clone();
		template.LocationInfo = new LocationInfo(this.GetCurrentChildTopOffset(), 0, this.SubMenuWidth, this.SubMenuHeight);
 		var item = new LeafItem(this.GetCurrentChildContainer(), 
 			text, 
 			template,
 			onClickFunction);
 		item.Create();
		this.AddChild(item);
		return item;
	}
	
	this.AddSubMenu = function(text, subSubMenuWidth, subSubMenuHeight)
	{
		var template = this.Template.Clone();
		template.LocationInfo = new LocationInfo(this.GetCurrentChildTopOffset(), 0, this.SubMenuWidth, this.SubMenuHeight);
		template.SubMenuSizeInfo = new SizeInfo(subSubMenuWidth, subSubMenuHeight);
		var sub = new SubMenuItem(this.GetCurrentChildContainer(), text, template);
		sub.Create();
		this.AddChild(sub);
		return sub;
	}
	
	this.GetCurrentChildContainer = function()
	{
		return this.Container + ".GetChildItem(" + this.Children.length + ")";
	}
	
	this.GetChildItem = function(index)
	{
		return this.Children[index];
	}
	
	this.ExpandChildrenNow = function()
	{
		this.ChildDiv.style.visibility = 'visible';
		for (var i=0; i<this.Children.length; ++i)
		{
			this.Children[i].Show();
		}
	}
	
	this.CollapseChildrenNow = function()
	{
		this.ChildDiv.style.visibility = 'hidden';
		for (var i=0; i<this.Children.length; ++i)
		{
			this.Children[i].Hide();
			if (this.Children[i].MenuType == MenuType.SubMenu)
			{
				this.Children[i].CollapseChildrenNow();
			}
		}
	}
	
	
	this.AddChild = function(item)
	{
		item.Parent = this;
		item.ZIndex = this.ZIndex+1;
		this.ChildDiv.style.border = this.Template.ChildBorderWidth + 'px solid ' + this.Template.ChildBorderColor;

		item.TextDiv.style.zIndex = item.ZIndex;

		this.ChildDiv.appendChild(item.RootDiv);
		this.Children[this.Children.length] = item;
		this.ChildDiv.style.height = this.Calculator.GetHeight(((this.SubMenuHeight-2*this.Template.ChildBorderWidth)*this.Children.length+2*this.Template.ChildBorderWidth), this.Template.ChildBorderWidth) + 'px';
	}
	
	this.GetCurrentChildTopOffset = function()
	{
		return this.Children.length * (this.SubMenuHeight-2*this.Template.ChildBorderWidth);
	}
		
	this.Create = function()
	{
		this.InitializeCalculator();
		this.CreateRootDiv();
		this.CreateTextDiv();
		this.CreateChildDiv();
		this.Children = new Array(0);
	}
	
	this.CreateChildDiv = function()
	{
		this.ChildDiv = this.CreateElement(
			this.Calculator.GetCalculatedChildTopOffset(0, this.GetBorderWidth()), 
			this.Calculator.GetCalculatedChildLeftOffset(this.Width, this.GetBorderWidth()), 
			this.Calculator.GetWidth(this.SubMenuWidth, this.GetBorderWidth()), 
			this.Calculator.GetHeight(this.Height, this.GetBorderWidth()));
		this.RootDiv.appendChild(this.ChildDiv);
	}
}

BaseMenuItem.Inherits(SubMenuItem);
function BaseMenuItem(container, text, template)
{
	this.Inherits(SubMenuItem, container, text, template);

	this.GetBorderWidth = function()
	{
		return this.Template.BaseBorderWidth;
	}
	
	this.GetDivClassName = function(hilite, loc)
	{
		if (hilite == true)
		{
			return 'div' + this.Template.CssPrefix + 'Base' + loc + 'Over';
		}
		else
		{
			return 'div' + this.Template.CssPrefix + 'Base' + loc;
		}
	}

	this.CreateChildDiv = function()
	{
		this.ChildDiv = this.CreateElement(
			this.Height,
			0,
			this.Calculator.GetWidth(this.SubMenuWidth, this.Template.ChildBorderWidth), 
			this.Calculator.GetHeight(this.Height, this.Template.ChildBorderWidth));
		this.RootDiv.appendChild(this.ChildDiv);
	}

	this.GetLeftDivWidth = function()
	{
		return this.Template.BaseLeftDivWidth;
	}
	
	this.GetRightDivWidth = function()
	{
		return this.Template.BaseRightDivWidth;
	}

	this.Create();
	
	this.OnMouseOver = function()
	{

		this.HiliteDiv();
	}
	
	this.OnMouseOut = function()
	{
		if (this.Expanded == true)
		{
			return;
		}
		this.UnHiliteDiv();
	
	}

	this.TextDiv.onclick = new Function("", this.Container + ".OnClick();");
	
	this.Expanded = false;
	this.OnClick = function()
	{
		if (this.Expanded == true)
		{
			this.CollapseChildrenNow();
		}
		else
		{
			this.ExpandChildrenNow();
		}
		this.Expanded = !this.Expanded;
	}

	this.TextDiv.style.border = this.GetBorderWidth() + 'px solid ' + this.Template.BaseBorderColor;
}

function GenericCalculator()
{
}

IECalculator.Inherits(GenericCalculator);
function IECalculator()
{
	this.Inherits(GenericCalculator);

	this.GetCalculatedChildLeftOffset = function(intended, borderWidth)
	{
		return intended - 2*borderWidth;
	}
	
	this.GetCalculatedChildTopOffset = function(intended, borderWidth)
	{
		return intended - 1*borderWidth;
	}
	
	this.GetWidth = function(intended)
	{
		return intended;
	}
	
	this.GetHeight = function(intended)
	{
		return intended;
	}
	
	this.GetPaddingBorderAdjustment = function(intended, borderWidth, padding)
	{
		return intended - 2*borderWidth;
	}
}

NonIECalculator.Inherits(GenericCalculator);
function NonIECalculator()
{
	this.Inherits(GenericCalculator);
	
	this.GetCalculatedChildLeftOffset = function(intended, borderWidth)
	{
		return intended - 2*borderWidth;
	}
	
	this.GetCalculatedChildTopOffset = function(intended, borderWidth)
	{
		return intended - 1*borderWidth;
	}

	this.GetWidth = function(intended, borderWidth)
	{
		return intended-2*borderWidth;
	}
	
	this.GetHeight = function(intended, borderWidth)
	{
		return intended-2*borderWidth;
	}
	
	this.GetPaddingBorderAdjustment = function(intended, borderWidth, padding)
	{
		return intended - 2*borderWidth - padding;
	}
}

function MenuTemplate()
{
	this.LocationInfo = new LocationInfo();
	this.SubMenuSizeInfo = new SizeInfo();
	
	this.LeftDivWidth = 0;//13;
	this.RightDivWidth = 0;//13;
	this.BaseLeftDivWidth = 0;
	this.BaseRightDivWidth = 0;//13;
	
	this.PaddingTop = 2;
	this.PaddingLeft = 10;
	
	this.BaseBorderWidth = 1;
	this.ChildBorderWidth = 1;
	this.BaseBorderColor = '#777';
	this.ChildBorderColor = '#777';
	
	this.CssPrefix = "";
	
	this.Clone = function()
	{
		var copy = new MenuTemplate();
		copy.LocationInfo = this.LocationInfo;
		copy.SubMenuSizeInfo = this.SubMenuSizeInfo;
		copy.LeftDivWidth = this.LeftDivWidth;
		copy.RightDivWidth = this.RightDivWidth;
		copy.BaseLeftDivWidth = this.BaseLeftDivWidth;
		copy.BaseRightDivWidth = this.BaseRightDivWidth;
		copy.PaddingTop = this.PaddingTop;
		copy.PaddingLeft = this.PaddingLeft;
		copy.BaseBorderColor = this.BaseBorderColor;
		copy.ChildBorderColor = this.ChildBorderColor;
		copy.CssPrefix = this.CssPrefix;
		return copy;
	}
}
// ENDFILE SfMenu.js ----------------------------------------------------------------------------->
